//【登録場所】全体、レス表示
//【ラベル】「マウスジェスチャ一覧」、または「キーバインド一覧」
//【内容】設定してあるマウスジェスチャ、またはキーバインドのみを新タブで表示。
//【コマンド1】${SCRIPT:Fr} viewMyMap.js 0 //キーバインドの設定一覧
//【コマンド2】${SCRIPT:Fr} viewMyMap.js 1 //マウスジェスチャの設定一覧
//【補足1】通常のアクション名取得にはttp://www39.atwiki.jp/v2cwiki/pages/49.htmlを利用、そのため、新しいアクションは置換されない可能性有り
//【補足2】スクリプトのアクション名取得にはextcmd_win.txtを利用、そのため、他のOSはたぶん未対応
var vcx = v2c.context;
var option = vcx.argLine;
function createMyMap(op){
	var f1 = new java.io.File( v2c.saveDir, '\\extcmd_win.txt' );
	var fa1 = v2c.readLinesFromFile(f1,'utf-8');
	var f2 = op ? new java.io.File(v2c.saveDir, '\\gesture.txt') : new java.io.File(v2c.saveDir, '\\inputmap.txt');
	var fa2 = v2c.readLinesFromFile(f2,'utf-8');
	for(var i = 0, il = fa1.length, m0 = m1 = m2 = ''; i < il; i++){
		s = fa1[i]+'';
		m0 = (s.match(/^\w/) || [])[0]
		m1 = (s.match(/\tI(\w+?)\t/) || [])[1];
		m2 = (s.match(/\tL(.+?)(\t|$)/) || [])[1];
		for(var j = 0, jl = fa2.length; j < jl; j++){
			fa2[j] = (fa2[j]+'').replace(new RegExp(m0+'\\$'+m1+'$'),m2);
		}
	}
	var se = v2c.readURL('h'+'ttp://www39.atwiki.jp/v2cwiki/pages/49.html');
	rgex = new RegExp('(<h4[^]*?<\/table>)','g');
	var ar = [];
	while(rgex.exec(se) != null){
		ar.push(RegExp.$1+'');
	}
	rgex = new RegExp('0--><td style="">([^<]*?)</td>[^]*?1--><td style="">([^<]*?)</td>','ig');
	for(var m = 0, ml = ar.length; m < ml; m++){
		while(rgex.exec(ar[m]) != null){
			for(var n = 0, nl = fa2.length; n < nl; n++){
				fa2[n] = (fa2[n]+'').replace(new RegExp(RegExp.$2+'$'),RegExp.$1);
			}
		}
	}
	for(var n = 0, nl = fa2.length; n < nl; n++){
			var ma = ((fa2[n].match(/^[\w ]+?,/) || [])[0])+'';
			var mp = ma;
			ma = ma.replace('Map,', '▼');
		if(op) {
			ma = ma.replace('S', 'S').replace(/U/g, '↑').replace(/D/g, '↓').replace(/L/g, '←').replace(/R/g, '→')
			.replace('u', 'W↑').replace('d', 'W↓').replace('1', 'L').replace('2', 'M').replace(',', '\t');
		} else {
			ma = ma.replace(/ /g, '　+　').replace('ctrl', 'CTRL').replace('alt', 'ALT').replace('shift', 'SHIFT');
			ma.length > 10 ? ma = ma.replace(',', '\t') : ma = ma.replace(',', '\t\t');
		}
		fa2[n] = (fa2[n]+'').replace(mp,ma).replace(/"/g,'"');
		fa2[n] = (fa2[n]+'').replace('Global','全体').replace('BoardTree','板一覧')
		.replace('Favorite','お気に入り').replace(/ThreadList$/,'スレッド一覧').replace(/ThreadView$/,'レス表示')
		.replace('TVLink','リンク[レス表示]').replace('TVThumbnail','サムネイル画像[レス表示]').replace('TVSelText','選択テキスト[レス表示]')
		.replace('Write','書き込み欄').replace('ThreadListMiniSearch','スレッド一覧絞り込み').replace('ThreadViewMiniSearch','レス表示絞り込み')
		.replace('ImageCacheList','画像キャッシュ一覧').replace('ImagePopup','画像ポップアップ・ビューア').replace('ImageWindow','画像表示ウィンドウ')+'\t';
	}
	var tt = op ? 'マウスジェスチャ設定' : 'キーバインド設定'
	vcx.setResPaneText(fa2.join('\n'), tt, true);
}
createMyMap(parseInt(option));
